from os import environ
from platform import system

CONFIG = {
    'framework' : 'nose',
    'arg' : 'zmq -v',
    'env' : None,
    'expect_except' : None,
    'need_sources' : False,
    'location' : None,
    'use_re' : False,
    'set_cl_path' : False,
    'parser' : 'pytest',
    'errors' : {
        '2.7' : {
            'Win' : set(),
            'Lin' : set(),
            'Mac' : set(),
        },
        '3.5' : {
            'Win' : set(),
            'Lin' : set(),
            'Mac' : set(),
        },
    },
    'failures' : { #SAT-1138
        '2.7' : {
            'Win' : {'TestEINTRSysCall.test_retry_recv',
                     'TestEINTRSysCall.test_retry_poll',
                     'TestEINTRSysCall.test_retry_send',
                     'TestEINTRSysCall.test_retry_term',
                     'TestMonitoredQueue.test_router_router',
                     'TestSecurity.test_plain'},
            'Lin' : set(),
            'Mac' : set()
        },
        '3.5' : {
            'Win' :  {'TestEINTRSysCall.test_retry_poll',
                      'TestEINTRSysCall.test_retry_send',
                      'TestAsyncioAuthentication.test_curve',
                      'TestEINTRSysCall.test_retry_recv',
                      'TestAsyncioAuthentication.test_plain',
                      'TestEINTRSysCall.test_retry_term',
                      'TestMonitoredQueue.test_router_router'},
            'Lin' : set(),
            'Mac' : set()
        },
    }
}

def fetch_config(pyver):
    if system() == "Windows":
        CONFIG['arg'] += ' --exclude="test_destroy|test_large_send" ' #SAT-1298,SAT-1385
    else:
        for ver in ['2.7', '3.5']:
            for plat in ['Lin', 'Mac']:
                CONFIG['errors'][ver][plat].add("Failure: ImportError (No module named 'gevent')")
                CONFIG['errors'][ver][plat].add("Failure: ImportError (No module named 'cffi')")
                CONFIG['errors'][ver][plat].add("Failure: ImportError (No module named gevent)")
                CONFIG['errors'][ver][plat].add("Failure: ImportError (No module named cffi)")
    return CONFIG
